CON
  zero = $1F0   ' par
var
  long  command, cog
  word  font[32]
    
PUB null
'' This is not a top level object.
PUB Start
  result := cog := cognew(@fillchar, @command) + 1        ' start cog     
PUB GetChar(c) 
  command := $200|c.byte{0}                             ' query bitmap
  repeat                                                ' |
  while command                                         ' wait for completion
  return @font{0}
    
DAT             org     0

fillchar        add     addr, par               ' @font[0]
:idle           rdlong  char, par wz
        if_z    jmp     #$-1

                mov     temp, char              ' where to begin
                shr     temp, #1                '  2 chars/long
                shl     temp, #7                ' 32 longs/char

                test    char, #1 wc
                muxnc   shft, #1                ' even/odd
                
                mov     lcnt, #32               ' 32 rows

:loop           rdlong  char, temp              ' read line from ROM
                shl     char, shft              ' adjust for even/odd

                shl     char, #2 wc
                rcl     line, #1                ' bit 15

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1                ' bit 12

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1                ' bit 8

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1                ' bit 4

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1

                shl     char, #2 wc
                rcl     line, #1                ' bit 0

                wrword  line, addr              ' update hub array
                add     addr, #2                ' advance dst
                add     temp, #4                ' advance src
                
                djnz    lcnt, #:loop            ' repeat

                sub     addr, #64
                
                wrlong  zero, par

                               ' rewind
                jmp     #:idle     

' initialised data and/or presets

addr            long    8
shft            long    0

' uninitialised data and/or temporaries

temp            res     1
char            res     1
lcnt            res     1
line            res     1

                fit